local sti = require("libs.sti")
local gamera = require("libs.gamera")
local camera = {}

function love.load()
    map = sti("tileset/pkr1.lua")
    offsetx, offsety = 0, 0
    scale = 1
    camera = gamera.new(-50, -50, map.width*map.tilewidth+50, map.height*map.tileheight+50)
    camera:setWindow(10,10,80,80)
    camera:setPosition(0, 0)
    camera:setScale(scale)
    print("world",camera:getWorld())
    print("window",camera:getWindow())
    print("position",camera:getPosition())
end

function love.draw()    
    camera:draw(function(x,y, w, h)    
        love.graphics.setColor(1,1,1)
        map:draw(-offsetx, -offsety, scale)
         love.graphics.setColor(0,1,0)
        love.graphics.rectangle("fill", offsetx, offsety, 8,8)  
    end)
end


function love.keypressed(key)
    if key == "escape" then
        love.event.quit()
    end
end


function love.update(dt)
    local speed = 96 * dt
    local pressMove = false

    if love.keyboard.isDown("up") then
        offsety = offsety - speed
        pressMove = true
    end

    if love.keyboard.isDown("down") then
        offsety = offsety + speed
        pressMove = true
    end

    if love.keyboard.isDown("left") then
        offsetx = offsetx - speed
        pressMove = true
    end
    
    if love.keyboard.isDown("right") then
        offsetx = offsetx + speed
        pressMove = true
    end
    
    if pressMove then
        print("offset", offsetx, offsety)
        camera:setPosition(offsetx, offsety)
        print("camerapos", camera:getPosition())
    end
end